=== tools/pao-ml/requirements.txt ===
nequip==0.16.1
torch
numpy
e3nn

#EOF
